require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_CPU_FEATURES_H)) {
    eval 'sub __ASM_CPU_FEATURES_H () {1;}' unless defined(&__ASM_CPU_FEATURES_H);
    require 'asm/cpu.ph';
    require 'asm/cpu-info.ph';
    require 'cpu-feature-overrides.ph';
    unless(defined(&cpu_has_tlb)) {
	eval 'sub cpu_has_tlb () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_TLB);}' unless defined(&cpu_has_tlb);
    }
    unless(defined(&cpu_has_4kex)) {
	eval 'sub cpu_has_4kex () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_4KEX);}' unless defined(&cpu_has_4kex);
    }
    unless(defined(&cpu_has_3k_cache)) {
	eval 'sub cpu_has_3k_cache () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_3K_CACHE);}' unless defined(&cpu_has_3k_cache);
    }
    eval 'sub cpu_has_6k_cache () {0;}' unless defined(&cpu_has_6k_cache);
    eval 'sub cpu_has_8k_cache () {0;}' unless defined(&cpu_has_8k_cache);
    unless(defined(&cpu_has_4k_cache)) {
	eval 'sub cpu_has_4k_cache () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_4K_CACHE);}' unless defined(&cpu_has_4k_cache);
    }
    unless(defined(&cpu_has_tx39_cache)) {
	eval 'sub cpu_has_tx39_cache () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_TX39_CACHE);}' unless defined(&cpu_has_tx39_cache);
    }
    unless(defined(&cpu_has_sb1_cache)) {
	eval 'sub cpu_has_sb1_cache () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_SB1_CACHE);}' unless defined(&cpu_has_sb1_cache);
    }
    unless(defined(&cpu_has_fpu)) {
	eval 'sub cpu_has_fpu () {( ($current_cpu_data->{options}) &  &MIPS_CPU_FPU);}' unless defined(&cpu_has_fpu);
    }
    unless(defined(&cpu_has_32fpr)) {
	eval 'sub cpu_has_32fpr () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_32FPR);}' unless defined(&cpu_has_32fpr);
    }
    unless(defined(&cpu_has_counter)) {
	eval 'sub cpu_has_counter () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_COUNTER);}' unless defined(&cpu_has_counter);
    }
    unless(defined(&cpu_has_watch)) {
	eval 'sub cpu_has_watch () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_WATCH);}' unless defined(&cpu_has_watch);
    }
    unless(defined(&cpu_has_divec)) {
	eval 'sub cpu_has_divec () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_DIVEC);}' unless defined(&cpu_has_divec);
    }
    unless(defined(&cpu_has_vce)) {
	eval 'sub cpu_has_vce () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_VCE);}' unless defined(&cpu_has_vce);
    }
    unless(defined(&cpu_has_cache_cdex_p)) {
	eval 'sub cpu_has_cache_cdex_p () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_CACHE_CDEX_P);}' unless defined(&cpu_has_cache_cdex_p);
    }
    unless(defined(&cpu_has_cache_cdex_s)) {
	eval 'sub cpu_has_cache_cdex_s () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_CACHE_CDEX_S);}' unless defined(&cpu_has_cache_cdex_s);
    }
    unless(defined(&cpu_has_prefetch)) {
	eval 'sub cpu_has_prefetch () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_PREFETCH);}' unless defined(&cpu_has_prefetch);
    }
    unless(defined(&cpu_has_mcheck)) {
	eval 'sub cpu_has_mcheck () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_MCHECK);}' unless defined(&cpu_has_mcheck);
    }
    unless(defined(&cpu_has_ejtag)) {
	eval 'sub cpu_has_ejtag () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_EJTAG);}' unless defined(&cpu_has_ejtag);
    }
    unless(defined(&cpu_has_llsc)) {
	eval 'sub cpu_has_llsc () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_LLSC);}' unless defined(&cpu_has_llsc);
    }
    unless(defined(&cpu_has_mips16)) {
	eval 'sub cpu_has_mips16 () {( ($cpu_data[0]->{ases}) &  &MIPS_ASE_MIPS16);}' unless defined(&cpu_has_mips16);
    }
    unless(defined(&cpu_has_mdmx)) {
	eval 'sub cpu_has_mdmx () {( ($cpu_data[0]->{ases}) &  &MIPS_ASE_MDMX);}' unless defined(&cpu_has_mdmx);
    }
    unless(defined(&cpu_has_mips3d)) {
	eval 'sub cpu_has_mips3d () {( ($cpu_data[0]->{ases}) &  &MIPS_ASE_MIPS3D);}' unless defined(&cpu_has_mips3d);
    }
    unless(defined(&cpu_has_smartmips)) {
	eval 'sub cpu_has_smartmips () {( ($cpu_data[0]->{ases}) &  &MIPS_ASE_SMARTMIPS);}' unless defined(&cpu_has_smartmips);
    }
    unless(defined(&cpu_has_vtag_icache)) {
	eval 'sub cpu_has_vtag_icache () {( ($cpu_data[0]->{icache}->{flags}) &  &MIPS_CACHE_VTAG);}' unless defined(&cpu_has_vtag_icache);
    }
    unless(defined(&cpu_has_dc_aliases)) {
	eval 'sub cpu_has_dc_aliases () {( ($cpu_data[0]->{dcache}->{flags}) &  &MIPS_CACHE_ALIASES);}' unless defined(&cpu_has_dc_aliases);
    }
    unless(defined(&cpu_has_ic_fills_f_dc)) {
	eval 'sub cpu_has_ic_fills_f_dc () {( ($cpu_data[0]->{icache}->{flags}) &  &MIPS_CACHE_IC_F_DC);}' unless defined(&cpu_has_ic_fills_f_dc);
    }
    unless(defined(&cpu_has_pindexed_dcache)) {
	eval 'sub cpu_has_pindexed_dcache () {( ($cpu_data[0]->{dcache}->{flags}) &  &MIPS_CACHE_PINDEX);}' unless defined(&cpu_has_pindexed_dcache);
    }
    unless(defined(&cpu_icache_snoops_remote_store)) {
	if(defined(&CONFIG_SMP)) {
	    eval 'sub cpu_icache_snoops_remote_store () {( ($cpu_data[0]->{icache}->{flags}) &  &MIPS_IC_SNOOPS_REMOTE);}' unless defined(&cpu_icache_snoops_remote_store);
	} else {
	    eval 'sub cpu_icache_snoops_remote_store () {1;}' unless defined(&cpu_icache_snoops_remote_store);
	}
    }
    unless(defined(&cpu_has_mips32r1)) {
	eval 'sub cpu_has_mips32r1 () {( ($cpu_data[0]->{isa_level}) &  &MIPS_CPU_ISA_M32R1);}' unless defined(&cpu_has_mips32r1);
    }
    unless(defined(&cpu_has_mips32r2)) {
	eval 'sub cpu_has_mips32r2 () {( ($cpu_data[0]->{isa_level}) &  &MIPS_CPU_ISA_M32R2);}' unless defined(&cpu_has_mips32r2);
    }
    unless(defined(&cpu_has_mips64r1)) {
	eval 'sub cpu_has_mips64r1 () {( ($cpu_data[0]->{isa_level}) &  &MIPS_CPU_ISA_M64R1);}' unless defined(&cpu_has_mips64r1);
    }
    unless(defined(&cpu_has_mips64r2)) {
	eval 'sub cpu_has_mips64r2 () {( ($cpu_data[0]->{isa_level}) &  &MIPS_CPU_ISA_M64R2);}' unless defined(&cpu_has_mips64r2);
    }
    eval 'sub cpu_has_mips32 () {( &cpu_has_mips32r1 |  &cpu_has_mips32r2);}' unless defined(&cpu_has_mips32);
    eval 'sub cpu_has_mips64 () {( &cpu_has_mips64r1 |  &cpu_has_mips64r2);}' unless defined(&cpu_has_mips64);
    eval 'sub cpu_has_mips_r1 () {( &cpu_has_mips32r1 |  &cpu_has_mips64r1);}' unless defined(&cpu_has_mips_r1);
    eval 'sub cpu_has_mips_r2 () {( &cpu_has_mips32r2 |  &cpu_has_mips64r2);}' unless defined(&cpu_has_mips_r2);
    unless(defined(&cpu_has_dsp)) {
	eval 'sub cpu_has_dsp () {( ($cpu_data[0]->{ases}) &  &MIPS_ASE_DSP);}' unless defined(&cpu_has_dsp);
    }
    unless(defined(&cpu_has_mipsmt)) {
	eval 'sub cpu_has_mipsmt () {( ($cpu_data[0]->{ases}) &  &MIPS_ASE_MIPSMT);}' unless defined(&cpu_has_mipsmt);
    }
    if(defined(&CONFIG_32BIT)) {
	unless(defined(&cpu_has_nofpuex)) {
	    eval 'sub cpu_has_nofpuex () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_NOFPUEX);}' unless defined(&cpu_has_nofpuex);
	}
	unless(defined(&cpu_has_64bits)) {
	    eval 'sub cpu_has_64bits () {( ($cpu_data[0]->{isa_level}) &  &MIPS_CPU_ISA_64BIT);}' unless defined(&cpu_has_64bits);
	}
	unless(defined(&cpu_has_64bit_zero_reg)) {
	    eval 'sub cpu_has_64bit_zero_reg () {( ($cpu_data[0]->{isa_level}) &  &MIPS_CPU_ISA_64BIT);}' unless defined(&cpu_has_64bit_zero_reg);
	}
	unless(defined(&cpu_has_64bit_gp_regs)) {
	    eval 'sub cpu_has_64bit_gp_regs () {0;}' unless defined(&cpu_has_64bit_gp_regs);
	}
	unless(defined(&cpu_has_64bit_addresses)) {
	    eval 'sub cpu_has_64bit_addresses () {0;}' unless defined(&cpu_has_64bit_addresses);
	}
    }
    if(defined(&CONFIG_64BIT)) {
	unless(defined(&cpu_has_nofpuex)) {
	    eval 'sub cpu_has_nofpuex () {0;}' unless defined(&cpu_has_nofpuex);
	}
	unless(defined(&cpu_has_64bits)) {
	    eval 'sub cpu_has_64bits () {1;}' unless defined(&cpu_has_64bits);
	}
	unless(defined(&cpu_has_64bit_zero_reg)) {
	    eval 'sub cpu_has_64bit_zero_reg () {1;}' unless defined(&cpu_has_64bit_zero_reg);
	}
	unless(defined(&cpu_has_64bit_gp_regs)) {
	    eval 'sub cpu_has_64bit_gp_regs () {1;}' unless defined(&cpu_has_64bit_gp_regs);
	}
	unless(defined(&cpu_has_64bit_addresses)) {
	    eval 'sub cpu_has_64bit_addresses () {1;}' unless defined(&cpu_has_64bit_addresses);
	}
    }
    if(defined( &CONFIG_CPU_MIPSR2_IRQ_VI)  && !defined( &cpu_has_vint)) {
	eval 'sub cpu_has_vint () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_VINT);}' unless defined(&cpu_has_vint);
    }
 elsif(!defined( &cpu_has_vint)) {
	eval 'sub cpu_has_vint () {0;}' unless defined(&cpu_has_vint);
    }
    if(defined( &CONFIG_CPU_MIPSR2_IRQ_EI)  && !defined( &cpu_has_veic)) {
	eval 'sub cpu_has_veic () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_VEIC);}' unless defined(&cpu_has_veic);
    }
 elsif(!defined( &cpu_has_veic)) {
	eval 'sub cpu_has_veic () {0;}' unless defined(&cpu_has_veic);
    }
    unless(defined(&cpu_has_inclusive_pcaches)) {
	eval 'sub cpu_has_inclusive_pcaches () {( ($cpu_data[0]->{options}) &  &MIPS_CPU_INCLUSIVE_CACHES);}' unless defined(&cpu_has_inclusive_pcaches);
    }
    unless(defined(&cpu_dcache_line_size)) {
	eval 'sub cpu_dcache_line_size () {
	    eval q( ($current_cpu_data->{dcache}->{linesz}));
	}' unless defined(&cpu_dcache_line_size);
    }
    unless(defined(&cpu_icache_line_size)) {
	eval 'sub cpu_icache_line_size () {
	    eval q( ($current_cpu_data->{icache}->{linesz}));
	}' unless defined(&cpu_icache_line_size);
    }
    unless(defined(&cpu_scache_line_size)) {
	eval 'sub cpu_scache_line_size () {
	    eval q( ($current_cpu_data->{scache}->{linesz}));
	}' unless defined(&cpu_scache_line_size);
    }
}
1;
