require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_DSP_H)) {
    eval 'sub _ASM_DSP_H () {1;}' unless defined(&_ASM_DSP_H);
    require 'asm/cpu.ph';
    require 'asm/cpu-features.ph';
    require 'asm/hazards.ph';
    require 'asm/mipsregs.ph';
    eval 'sub DSP_DEFAULT () {0x;}' unless defined(&DSP_DEFAULT);
    eval 'sub DSP_MASK () {0x3ff;}' unless defined(&DSP_MASK);
    eval 'sub __enable_dsp_hazard () {
        eval q( &do {  &asm(\\"_ehb\\"); }  &while (0));
    }' unless defined(&__enable_dsp_hazard);
    eval 'sub __init_dsp {
        my($void) = @_;
	    eval q({  &mthi1(0);  &mtlo1(0);  &mthi2(0);  &mtlo2(0);  &mthi3(0);  &mtlo3(0);  &wrdsp( &DSP_DEFAULT,  &DSP_MASK); });
    }' unless defined(&__init_dsp);
    eval 'sub init_dsp {
        my($void) = @_;
	    eval q({  &if ( &cpu_has_dsp)  &__init_dsp(); });
    }' unless defined(&init_dsp);
    eval 'sub __save_dsp {
        my($tsk) = @_;
	    eval q( &do {  ($tsk->{thread}->{dsp}->{dspr[0]}) =  &mfhi1();  ($tsk->{thread}->{dsp}->{dspr[1]}) =  &mflo1();  ($tsk->{thread}->{dsp}->{dspr[2]}) =  &mfhi2();  ($tsk->{thread}->{dsp}->{dspr[3]}) =  &mflo2();  ($tsk->{thread}->{dsp}->{dspr[4]}) =  &mfhi3();  ($tsk->{thread}->{dsp}->{dspr[5]}) =  &mflo3();  ($tsk->{thread}->{dsp}->{dspcontrol}) =  &rddsp( &DSP_MASK); }  &while (0));
    }' unless defined(&__save_dsp);
    eval 'sub save_dsp {
        my($tsk) = @_;
	    eval q( &do {  &if ( &cpu_has_dsp)  &__save_dsp($tsk); }  &while (0));
    }' unless defined(&save_dsp);
    eval 'sub __restore_dsp {
        my($tsk) = @_;
	    eval q( &do {  &mthi1( ($tsk->{thread}->{dsp}->{dspr[0]}));  &mtlo1( ($tsk->{thread}->{dsp}->{dspr[1]}));  &mthi2( ($tsk->{thread}->{dsp}->{dspr[2]}));  &mtlo2( ($tsk->{thread}->{dsp}->{dspr[3]}));  &mthi3( ($tsk->{thread}->{dsp}->{dspr[4]}));  &mtlo3( ($tsk->{thread}->{dsp}->{dspr[5]}));  &wrdsp( ($tsk->{thread}->{dsp}->{dspcontrol}),  &DSP_MASK); }  &while (0));
    }' unless defined(&__restore_dsp);
    eval 'sub restore_dsp {
        my($tsk) = @_;
	    eval q( &do {  &if ( &cpu_has_dsp)  &__restore_dsp($tsk); }  &while (0));
    }' unless defined(&restore_dsp);
    eval 'sub __get_dsp_regs {
        my($tsk) = @_;
	    eval q(({  &if ($tsk ==  &current)  &__save_dsp( &current);  ($tsk->{thread}->{dsp}->{dspr}); }));
    }' unless defined(&__get_dsp_regs);
}
1;
