require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_MODULE_H)) {
    eval 'sub _ASM_MODULE_H () {1;}' unless defined(&_ASM_MODULE_H);
    require 'linux/list.ph';
    require 'asm/uaccess.ph';
    if(defined(&CONFIG_32BIT)) {
	eval 'sub Elf_Shdr () { &Elf32_Shdr;}' unless defined(&Elf_Shdr);
	eval 'sub Elf_Sym () { &Elf32_Sym;}' unless defined(&Elf_Sym);
	eval 'sub Elf_Ehdr () { &Elf32_Ehdr;}' unless defined(&Elf_Ehdr);
	eval 'sub Elf_Addr () { &Elf32_Addr;}' unless defined(&Elf_Addr);
	eval 'sub Elf_Mips_Rel () { &Elf32_Rel;}' unless defined(&Elf_Mips_Rel);
	eval 'sub Elf_Mips_Rela () { &Elf32_Rela;}' unless defined(&Elf_Mips_Rela);
	eval 'sub ELF_MIPS_R_SYM {
	    my($rel) = @_;
    	    eval q( &ELF32_R_SYM( ($rel->{r_info})));
	}' unless defined(&ELF_MIPS_R_SYM);
	eval 'sub ELF_MIPS_R_TYPE {
	    my($rel) = @_;
    	    eval q( &ELF32_R_TYPE( ($rel->{r_info})));
	}' unless defined(&ELF_MIPS_R_TYPE);
    }
    if(defined(&CONFIG_64BIT)) {
	eval 'sub Elf_Shdr () { &Elf64_Shdr;}' unless defined(&Elf_Shdr);
	eval 'sub Elf_Sym () { &Elf64_Sym;}' unless defined(&Elf_Sym);
	eval 'sub Elf_Ehdr () { &Elf64_Ehdr;}' unless defined(&Elf_Ehdr);
	eval 'sub Elf_Addr () { &Elf64_Addr;}' unless defined(&Elf_Addr);
	eval 'sub Elf_Mips_Rel () { &Elf64_Mips_Rel;}' unless defined(&Elf_Mips_Rel);
	eval 'sub Elf_Mips_Rela () { &Elf64_Mips_Rela;}' unless defined(&Elf_Mips_Rela);
	eval 'sub ELF_MIPS_R_SYM {
	    my($rel) = @_;
    	    eval q(( ($rel->{r_sym})));
	}' unless defined(&ELF_MIPS_R_SYM);
	eval 'sub ELF_MIPS_R_TYPE {
	    my($rel) = @_;
    	    eval q(( ($rel->{r_type})));
	}' unless defined(&ELF_MIPS_R_TYPE);
    }
    if(defined(&CONFIG_MODULES)) {
    } else {
    }
    if(defined(&CONFIG_CPU_MIPS32_R1)) {
	eval 'sub MODULE_PROC_FAMILY () {"MIPS32_R1 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_MIPS32_R2) ? &CONFIG_CPU_MIPS32_R2 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"MIPS32_R2 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_MIPS64_R1) ? &CONFIG_CPU_MIPS64_R1 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"MIPS64_R1 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_MIPS64_R2) ? &CONFIG_CPU_MIPS64_R2 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"MIPS64_R2 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R3000) ? &CONFIG_CPU_R3000 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R3000 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_TX39XX) ? &CONFIG_CPU_TX39XX : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"TX39XX ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_VR41XX) ? &CONFIG_CPU_VR41XX : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"VR41XX ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R4300) ? &CONFIG_CPU_R4300 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R4300 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R4X00) ? &CONFIG_CPU_R4X00 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R4X00 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_TX49XX) ? &CONFIG_CPU_TX49XX : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"TX49XX ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R5000) ? &CONFIG_CPU_R5000 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R5000 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R5432) ? &CONFIG_CPU_R5432 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R5432 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R6000) ? &CONFIG_CPU_R6000 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R6000 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_NEVADA) ? &CONFIG_CPU_NEVADA : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"NEVADA ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R8000) ? &CONFIG_CPU_R8000 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R8000 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_R10000) ? &CONFIG_CPU_R10000 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"R10000 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_RM7000) ? &CONFIG_CPU_RM7000 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"RM7000 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_RM9000) ? &CONFIG_CPU_RM9000 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"RM9000 ";}' unless defined(&MODULE_PROC_FAMILY);
    }
 elsif(defined (defined(&CONFIG_CPU_SB1) ? &CONFIG_CPU_SB1 : 0)) {
	eval 'sub MODULE_PROC_FAMILY () {"SB1 ";}' unless defined(&MODULE_PROC_FAMILY);
    } else {
	die("MODULE_PROC_FAMILY\ undefined\ for\ your\ processor\ configuration");
    }
    if(defined(&CONFIG_32BIT)) {
	eval 'sub MODULE_KERNEL_TYPE () {"32BIT ";}' unless defined(&MODULE_KERNEL_TYPE);
    }
 elsif(defined (defined(&CONFIG_64BIT) ? &CONFIG_64BIT : 0)) {
	eval 'sub MODULE_KERNEL_TYPE () {"64BIT ";}' unless defined(&MODULE_KERNEL_TYPE);
    }
    eval 'sub MODULE_ARCH_VERMAGIC () { &MODULE_PROC_FAMILY  &MODULE_KERNEL_TYPE;}' unless defined(&MODULE_ARCH_VERMAGIC);
}
1;
