require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PAGE_H)) {
    eval 'sub _ASM_PAGE_H () {1;}' unless defined(&_ASM_PAGE_H);
    if(defined(&__KERNEL__)) {
	require 'spaces.ph';
	if(defined(&CONFIG_PAGE_SIZE_4KB)) {
	    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
	}
	if(defined(&CONFIG_PAGE_SIZE_8KB)) {
	    eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
	}
	if(defined(&CONFIG_PAGE_SIZE_16KB)) {
	    eval 'sub PAGE_SHIFT () {14;}' unless defined(&PAGE_SHIFT);
	}
	if(defined(&CONFIG_PAGE_SIZE_64KB)) {
	    eval 'sub PAGE_SHIFT () {16;}' unless defined(&PAGE_SHIFT);
	}
	eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
	eval 'sub PAGE_MASK () {(~((1<<  &PAGE_SHIFT) - 1));}' unless defined(&PAGE_MASK);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub pages_do_alias {
	        my($addr1,$addr2) = @_;
    		eval q({ ($addr1 ^ $addr2) &  &shm_align_mask; });
	    }' unless defined(&pages_do_alias);
	    eval 'sub clear_user_page {
	        my($addr,$vaddr,$page) = @_;
    		eval q({  &void (* &flush_data_cache_page);  &clear_page($addr);  &if ( &pages_do_alias( $addr, $vaddr))  &flush_data_cache_page($addr); });
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        my($vto,$vfrom,$vaddr,$to) = @_;
    		eval q({  &void (* &flush_data_cache_page);  &copy_page($vto, $vfrom);  &if ( &pages_do_alias($vto, $vaddr))  &flush_data_cache_page($vto); });
	    }' unless defined(&copy_user_page);
	    if(defined(&CONFIG_64BIT_PHYS_ADDR)) {
		if(defined(&CONFIG_CPU_MIPS32)) {
		    eval 'sub pte_val {
		        my($x) = @_;
    			eval q((($x). &pte_low | (($x). &pte_high << 32)));
		    }' unless defined(&pte_val);
		} else {
		    eval 'sub pte_val {
		        my($x) = @_;
    			eval q((($x). &pte));
		    }' unless defined(&pte_val);
		}
	    } else {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
	    }
	    eval 'sub __pte {
	        my($x) = @_;
    		eval q((( &pte_t) { ($x) } ));
	    }' unless defined(&__pte);
	    if(defined(&CONFIG_64BIT)) {
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
	    }
	    eval 'sub pgd_val {
	        my($x) = @_;
    		eval q((($x). &pgd));
	    }' unless defined(&pgd_val);
	    eval 'sub __pgd {
	        my($x) = @_;
    		eval q((( &pgd_t) { ($x) } ));
	    }' unless defined(&__pgd);
	    eval 'sub pgprot_val {
	        my($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pgprot {
	        my($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	    eval 'sub ptep_buddy {
	        my($x) = @_;
    		eval q((( &pte_t *)(($x) ^ $sizeof{ &pte_t})));
	    }' unless defined(&ptep_buddy);
	}
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr) +  &PAGE_SIZE - 1) &  &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub __pa {
	    my($x) = @_;
    	    eval q(( ($x) -  &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    my($x) = @_;
    	    eval q((( &void *)( ($x) +  &PAGE_OFFSET)));
	}' unless defined(&__va);
	eval 'sub pfn_to_kaddr {
	    my($pfn) = @_;
    	    eval q( &__va(($pfn) <<  &PAGE_SHIFT));
	}' unless defined(&pfn_to_kaddr);
	if(defined(&CONFIG_FLATMEM)) {
	    eval 'sub pfn_valid {
	        my($pfn) = @_;
    		eval q((($pfn) <  &max_mapnr));
	    }' unless defined(&pfn_valid);
	}
 elsif(defined( &CONFIG_SPARSEMEM)) {
	}
 elsif(defined( &CONFIG_NEED_MULTIPLE_NODES)) {
	    eval 'sub pfn_valid {
	        my($pfn) = @_;
    		eval q(({ \'unsigned long __pfn\' = ($pfn); \'int\'  &__n =  &pfn_to_nid( &__pfn); (( &__n >= 0) ? ( &__pfn <  &NODE_DATA( &__n)-> &node_start_pfn +  &NODE_DATA( &__n)-> &node_spanned_pages) : 0); }));
	    }' unless defined(&pfn_valid);
	}
	eval 'sub virt_to_page {
	    my($kaddr) = @_;
    	    eval q( &pfn_to_page( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_to_page);
	eval 'sub virt_addr_valid {
	    my($kaddr) = @_;
    	    eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_addr_valid);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
	eval 'sub UNCAC_ADDR {
	    my($addr) = @_;
    	    eval q((($addr) -  &PAGE_OFFSET +  &UNCAC_BASE));
	}' unless defined(&UNCAC_ADDR);
	eval 'sub CAC_ADDR {
	    my($addr) = @_;
    	    eval q((($addr) -  &UNCAC_BASE +  &PAGE_OFFSET));
	}' unless defined(&CAC_ADDR);
	if(defined(&CONFIG_LIMITED_DMA)) {
	    eval 'sub WANT_PAGE_VIRTUAL () {1;}' unless defined(&WANT_PAGE_VIRTUAL);
	}
	require 'asm-generic/memory_model.ph';
	require 'asm-generic/page.ph';
    }
}
1;
