require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PROCESSOR_H)) {
    eval 'sub _ASM_PROCESSOR_H () {1;}' unless defined(&_ASM_PROCESSOR_H);
    require 'linux/cpumask.ph';
    require 'linux/threads.ph';
    require 'asm/cachectl.ph';
    require 'asm/cpu.ph';
    require 'asm/cpu-info.ph';
    require 'asm/mipsregs.ph';
    require 'asm/prefetch.ph';
    require 'asm/system.ph';
    eval 'sub current_text_addr () {
        eval q(({  &__label__  &_l;  &_l:  && &_l;}));
    }' unless defined(&current_text_addr);
    if(defined(&CONFIG_32BIT)) {
	eval 'sub TASK_SIZE () {0x7fff8000;}' unless defined(&TASK_SIZE);
	eval 'sub TASK_UNMAPPED_BASE () {( &PAGE_ALIGN( &TASK_SIZE / 3));}' unless defined(&TASK_UNMAPPED_BASE);
    }
    if(defined(&CONFIG_64BIT)) {
	eval 'sub TASK_SIZE32 () {0x7fff8000;}' unless defined(&TASK_SIZE32);
	eval 'sub TASK_SIZE () {1099511627776;}' unless defined(&TASK_SIZE);
	eval 'sub TASK_UNMAPPED_BASE () {(( ($current->{thread}->{mflags}) &  &MF_32BIT_ADDR) ?  &PAGE_ALIGN( &TASK_SIZE32 / 3) :  &PAGE_ALIGN( &TASK_SIZE / 3));}' unless defined(&TASK_UNMAPPED_BASE);
    }
    eval 'sub NUM_FPU_REGS () {32;}' unless defined(&NUM_FPU_REGS);
    eval 'sub INIT_FPU () {{ {0,} };}' unless defined(&INIT_FPU);
    eval 'sub NUM_DSP_REGS () {6;}' unless defined(&NUM_DSP_REGS);
    eval 'sub INIT_DSP () {{{0,},};}' unless defined(&INIT_DSP);
    eval 'sub INIT_CPUMASK () {{ {0,} };}' unless defined(&INIT_CPUMASK);
    eval 'sub ARCH_MIN_TASKALIGN () {8;}' unless defined(&ARCH_MIN_TASKALIGN);
    if(defined(&CONFIG_MIPS_MT_FPAFF)) {
    }
    eval 'sub MF_FIXADE () {1;}' unless defined(&MF_FIXADE);
    eval 'sub MF_LOGADE () {2;}' unless defined(&MF_LOGADE);
    eval 'sub MF_32BIT_REGS () {4;}' unless defined(&MF_32BIT_REGS);
    eval 'sub MF_32BIT_ADDR () {8;}' unless defined(&MF_32BIT_ADDR);
    eval 'sub MF_FPUBOUND () {0x10;}' unless defined(&MF_FPUBOUND);
    eval 'sub MF_ABI_MASK () {( &MF_32BIT_REGS |  &MF_32BIT_ADDR);}' unless defined(&MF_ABI_MASK);
    eval 'sub MF_O32 () {( &MF_32BIT_REGS |  &MF_32BIT_ADDR);}' unless defined(&MF_O32);
    eval 'sub MF_N32 () { &MF_32BIT_ADDR;}' unless defined(&MF_N32);
    eval 'sub MF_N64 () {0;}' unless defined(&MF_N64);
    if(defined(&CONFIG_MIPS_MT_FPAFF)) {
	eval 'sub FPAFF_INIT () {0,  &INIT_CPUMASK,;}' unless defined(&FPAFF_INIT);
    } else {
	eval 'sub FPAFF_INIT () {1;}' unless defined(&FPAFF_INIT);
    }
    eval 'sub INIT_THREAD () {{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  &INIT_FPU,  &FPAFF_INIT  &INIT_DSP, 0, 0, 0, 0,  &MF_FIXADE, 0, 0};}' unless defined(&INIT_THREAD);
    eval 'sub release_thread {
        my($thread) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&release_thread);
    eval 'sub prepare_to_copy {
        my($tsk) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&prepare_to_copy);
    eval 'sub __KSTK_TOS {
        my($tsk) = @_;
	    eval q(( &task_stack_page($tsk) +  &THREAD_SIZE - 32));
    }' unless defined(&__KSTK_TOS);
    eval 'sub task_pt_regs {
        my($tsk) = @_;
	    eval q(( &__KSTK_TOS($tsk) - 1));
    }' unless defined(&task_pt_regs);
    eval 'sub KSTK_EIP {
        my($tsk) = @_;
	    eval q(( &task_pt_regs($tsk)-> &cp0_epc));
    }' unless defined(&KSTK_EIP);
    eval 'sub KSTK_ESP {
        my($tsk) = @_;
	    eval q(( &task_pt_regs($tsk)-> $regs[29]));
    }' unless defined(&KSTK_ESP);
    eval 'sub KSTK_STATUS {
        my($tsk) = @_;
	    eval q(( &task_pt_regs($tsk)-> &cp0_status));
    }' unless defined(&KSTK_STATUS);
    eval 'sub cpu_relax () {
        eval q( &barrier());
    }' unless defined(&cpu_relax);
    eval 'sub return_address () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&return_address);
    if(defined(&CONFIG_CPU_HAS_PREFETCH)) {
	eval 'sub ARCH_HAS_PREFETCH () {1;}' unless defined(&ARCH_HAS_PREFETCH);
    }
}
1;
