require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SIGNAL_H)) {
    eval 'sub _ASM_SIGNAL_H () {1;}' unless defined(&_ASM_SIGNAL_H);
    require 'linux/types.ph';
    eval 'sub _NSIG () {128;}' unless defined(&_NSIG);
    eval 'sub _NSIG_BPW () {($sizeof{\'unsigned long\'} * 8);}' unless defined(&_NSIG_BPW);
    eval 'sub _NSIG_WORDS () {( &_NSIG /  &_NSIG_BPW);}' unless defined(&_NSIG_WORDS);
    eval 'sub SIGHUP () {1;}' unless defined(&SIGHUP);
    eval 'sub SIGINT () {2;}' unless defined(&SIGINT);
    eval 'sub SIGQUIT () {3;}' unless defined(&SIGQUIT);
    eval 'sub SIGILL () {4;}' unless defined(&SIGILL);
    eval 'sub SIGTRAP () {5;}' unless defined(&SIGTRAP);
    eval 'sub SIGIOT () {6;}' unless defined(&SIGIOT);
    eval 'sub SIGABRT () { &SIGIOT;}' unless defined(&SIGABRT);
    eval 'sub SIGEMT () {7;}' unless defined(&SIGEMT);
    eval 'sub SIGFPE () {8;}' unless defined(&SIGFPE);
    eval 'sub SIGKILL () {9;}' unless defined(&SIGKILL);
    eval 'sub SIGBUS () {10;}' unless defined(&SIGBUS);
    eval 'sub SIGSEGV () {11;}' unless defined(&SIGSEGV);
    eval 'sub SIGSYS () {12;}' unless defined(&SIGSYS);
    eval 'sub SIGPIPE () {13;}' unless defined(&SIGPIPE);
    eval 'sub SIGALRM () {14;}' unless defined(&SIGALRM);
    eval 'sub SIGTERM () {15;}' unless defined(&SIGTERM);
    eval 'sub SIGUSR1 () {16;}' unless defined(&SIGUSR1);
    eval 'sub SIGUSR2 () {17;}' unless defined(&SIGUSR2);
    eval 'sub SIGCHLD () {18;}' unless defined(&SIGCHLD);
    eval 'sub SIGCLD () { &SIGCHLD;}' unless defined(&SIGCLD);
    eval 'sub SIGPWR () {19;}' unless defined(&SIGPWR);
    eval 'sub SIGWINCH () {20;}' unless defined(&SIGWINCH);
    eval 'sub SIGURG () {21;}' unless defined(&SIGURG);
    eval 'sub SIGIO () {22;}' unless defined(&SIGIO);
    eval 'sub SIGPOLL () { &SIGIO;}' unless defined(&SIGPOLL);
    eval 'sub SIGSTOP () {23;}' unless defined(&SIGSTOP);
    eval 'sub SIGTSTP () {24;}' unless defined(&SIGTSTP);
    eval 'sub SIGCONT () {25;}' unless defined(&SIGCONT);
    eval 'sub SIGTTIN () {26;}' unless defined(&SIGTTIN);
    eval 'sub SIGTTOU () {27;}' unless defined(&SIGTTOU);
    eval 'sub SIGVTALRM () {28;}' unless defined(&SIGVTALRM);
    eval 'sub SIGPROF () {29;}' unless defined(&SIGPROF);
    eval 'sub SIGXCPU () {30;}' unless defined(&SIGXCPU);
    eval 'sub SIGXFSZ () {31;}' unless defined(&SIGXFSZ);
    eval 'sub SIGRTMIN () {32;}' unless defined(&SIGRTMIN);
    eval 'sub SIGRTMAX () { &_NSIG;}' unless defined(&SIGRTMAX);
    eval 'sub SA_ONSTACK () {0x8000000;}' unless defined(&SA_ONSTACK);
    eval 'sub SA_RESETHAND () {0x80000000;}' unless defined(&SA_RESETHAND);
    eval 'sub SA_RESTART () {0x10000000;}' unless defined(&SA_RESTART);
    eval 'sub SA_SIGINFO () {0x8;}' unless defined(&SA_SIGINFO);
    eval 'sub SA_NODEFER () {0x40000000;}' unless defined(&SA_NODEFER);
    eval 'sub SA_NOCLDWAIT () {0x10000;}' unless defined(&SA_NOCLDWAIT);
    eval 'sub SA_NOCLDSTOP () {0x1;}' unless defined(&SA_NOCLDSTOP);
    eval 'sub SA_NOMASK () { &SA_NODEFER;}' unless defined(&SA_NOMASK);
    eval 'sub SA_ONESHOT () { &SA_RESETHAND;}' unless defined(&SA_ONESHOT);
    eval 'sub SA_RESTORER () {0x4000000;}' unless defined(&SA_RESTORER);
    eval 'sub SS_ONSTACK () {1;}' unless defined(&SS_ONSTACK);
    eval 'sub SS_DISABLE () {2;}' unless defined(&SS_DISABLE);
    eval 'sub MINSIGSTKSZ () {2048;}' unless defined(&MINSIGSTKSZ);
    eval 'sub SIGSTKSZ () {8192;}' unless defined(&SIGSTKSZ);
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_TRAD_SIGNALS)) {
	    eval 'sub sig_uses_siginfo {
	        my($ka) = @_;
    		eval q((($ka)-> ($sa->{sa_flags}) &  &SA_SIGINFO));
	    }' unless defined(&sig_uses_siginfo);
	} else {
	    eval 'sub sig_uses_siginfo {
	        my($ka) = @_;
    		eval q((1));
	    }' unless defined(&sig_uses_siginfo);
	}
    }
    eval 'sub SIG_BLOCK () {1;}' unless defined(&SIG_BLOCK);
    eval 'sub SIG_UNBLOCK () {2;}' unless defined(&SIG_UNBLOCK);
    eval 'sub SIG_SETMASK () {3;}' unless defined(&SIG_SETMASK);
    eval 'sub SIG_SETMASK32 () {256;}' unless defined(&SIG_SETMASK32);
    eval 'sub SIG_DFL () {(( &__sighandler_t)0);}' unless defined(&SIG_DFL);
    eval 'sub SIG_IGN () {(( &__sighandler_t)1);}' unless defined(&SIG_IGN);
    eval 'sub SIG_ERR () {(( &__sighandler_t)-1);}' unless defined(&SIG_ERR);
    if(defined(&CONFIG_BINFMT_IRIX)) {
    }
    if(defined(&__KERNEL__)) {
	require 'asm/sigcontext.ph';
	require 'asm/siginfo.ph';
	eval 'sub ptrace_signal_deliver {
	    my($regs, $cookie) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&ptrace_signal_deliver);
    }
}
1;
