require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_SYSTEM_H)) {
    eval 'sub _ASM_SYSTEM_H () {1;}' unless defined(&_ASM_SYSTEM_H);
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
	require 'linux/irqflags.ph';
	require 'asm/addrspace.ph';
	require 'asm/cpu-features.ph';
	require 'asm/dsp.ph';
	require 'asm/ptrace.ph';
	require 'asm/war.ph';
	eval 'sub read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&read_barrier_depends);
	if(defined(&CONFIG_CPU_HAS_SYNC)) {
	    eval 'sub __sync () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&__sync);
	} else {
	    eval 'sub __sync () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&__sync);
	}
	eval 'sub __fast_iob () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&__fast_iob);
	eval 'sub fast_wmb () {
	    eval q( &__sync());
	}' unless defined(&fast_wmb);
	eval 'sub fast_rmb () {
	    eval q( &__sync());
	}' unless defined(&fast_rmb);
	eval 'sub fast_mb () {
	    eval q( &__sync());
	}' unless defined(&fast_mb);
	eval 'sub fast_iob () {
	    eval q( &do {  &__sync();  &__fast_iob(); }  &while (0));
	}' unless defined(&fast_iob);
	if(defined(&CONFIG_CPU_HAS_WB)) {
	    require 'asm/wbflush.ph';
	    eval 'sub wmb () {
	        eval q( &fast_wmb());
	    }' unless defined(&wmb);
	    eval 'sub rmb () {
	        eval q( &fast_rmb());
	    }' unless defined(&rmb);
	    eval 'sub mb () {
	        eval q( &wbflush());
	    }' unless defined(&mb);
	    eval 'sub iob () {
	        eval q( &wbflush());
	    }' unless defined(&iob);
	} else {
	    eval 'sub wmb () {
	        eval q( &fast_wmb());
	    }' unless defined(&wmb);
	    eval 'sub rmb () {
	        eval q( &fast_rmb());
	    }' unless defined(&rmb);
	    eval 'sub mb () {
	        eval q( &fast_mb());
	    }' unless defined(&mb);
	    eval 'sub iob () {
	        eval q( &fast_iob());
	    }' unless defined(&iob);
	}
	if(defined(&CONFIG_SMP)) {
	    eval 'sub smp_mb () {
	        eval q( &mb());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &rmb());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &wmb());
	    }' unless defined(&smp_wmb);
	    eval 'sub smp_read_barrier_depends () {
	        eval q( &read_barrier_depends());
	    }' unless defined(&smp_read_barrier_depends);
	} else {
	    eval 'sub smp_mb () {
	        eval q( &barrier());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_wmb);
	    eval 'sub smp_read_barrier_depends () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&smp_read_barrier_depends);
	}
	eval 'sub set_mb {
	    my($var, $value) = @_;
    	    eval q( &do { $var = $value;  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	if(defined(&CONFIG_MIPS_MT_FPAFF)) {
	    eval 'sub switch_to {
	        my($prev,$next,$last) = @_;
    		eval q( &do {  &if ( &cpu_has_fpu  && ( ($prev->{thread}->{mflags}) &  &MF_FPUBOUND)  && (!( &KSTK_STATUS($prev) &  &ST0_CU1))) {  ($prev->{thread}->{mflags}) &= ~ &MF_FPUBOUND;  ($prev->{cpus_allowed}) =  ($prev->{thread}->{user_cpus_allowed}); }  &if ( &cpu_has_dsp)  &__save_dsp($prev);  ($next->{thread}->{emulated_fp}) = 0; ($last) =  &resume($prev, $next,  ($next->{thread_info}));  &if ( &cpu_has_dsp)  &__restore_dsp( &current); }  &while(0));
	    }' unless defined(&switch_to);
	} else {
	    eval 'sub switch_to {
	        my($prev,$next,$last) = @_;
    		eval q( &do {  &if ( &cpu_has_dsp)  &__save_dsp($prev); ($last) =  &resume($prev, $next,  &task_thread_info($next));  &if ( &cpu_has_dsp)  &__restore_dsp( &current); }  &while(0));
	    }' unless defined(&switch_to);
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __xchg_u32 {
	    my($m,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__xchg_u32);
	if(defined(&CONFIG_64BIT)) {
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub __xchg_u64 {
	        my($m,$val) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__xchg_u64);
	} else {
	    eval 'sub __xchg_u64 () { &__xchg_u64_unsupported_on_32bit_kernels;}' unless defined(&__xchg_u64);
	}
	eval 'sub __xchg {
	    my($x,$ptr,$size) = @_;
    	    eval q({  &switch ($size) {  &case 4:  &__xchg_u32($ptr, $x);  &case 8:  &__xchg_u64($ptr, $x); }  &__xchg_called_with_bad_pointer(); $x; });
	}' unless defined(&__xchg);
	eval 'sub xchg {
	    my($ptr,$x) = @_;
    	    eval q((( &__typeof__(*($ptr))) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub tas {
	    my($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u32 {
	    my($m,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u32);
	if(defined(&CONFIG_64BIT)) {
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub __cmpxchg_u64 {
	        my($m,$old,$new) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__cmpxchg_u64);
	} else {
	    eval 'sub __cmpxchg_u64 () { &__cmpxchg_u64_unsupported_on_32bit_kernels;}' unless defined(&__cmpxchg_u64);
	}
	eval 'sub __cmpxchg {
	    my($ptr,$old,$new,$size) = @_;
    	    eval q({  &switch ($size) {  &case 4:  &__cmpxchg_u32($ptr, $old, $new);  &case 8:  &__cmpxchg_u64($ptr, $old, $new); }  &__cmpxchg_called_with_bad_pointer(); $old; });
	}' unless defined(&__cmpxchg);
	eval 'sub cmpxchg {
	    my($ptr,$old,$new) = @_;
    	    eval q((( &__typeof__(*($ptr))) &__cmpxchg(($ptr), ($old), ($new),$sizeof{($ptr)})));
	}' unless defined(&cmpxchg);
	eval 'sub die_if_kernel {
	    my($str,$regs) = @_;
    	    eval q({  &if ( &unlikely(! &user_mode($regs)))  &die($str, $regs); });
	}' unless defined(&die_if_kernel);
	eval 'sub __ARCH_WANT_UNLOCKED_CTXSW () {1;}' unless defined(&__ARCH_WANT_UNLOCKED_CTXSW);
	eval 'sub arch_align_stack {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&arch_align_stack);
    }
}
1;
