require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_THREAD_INFO_H)) {
    eval 'sub _ASM_THREAD_INFO_H () {1;}' unless defined(&_ASM_THREAD_INFO_H);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/processor.ph';
	    eval 'sub INIT_THREAD_INFO {
	        my($tsk) = @_;
    		eval q({ . &task = $tsk, . &exec_domain =  &default_exec_domain, . &flags = 0, . &cpu = 0, . &preempt_count = 1, . &addr_limit =  &KERNEL_DS, . &restart_block = { . &fn =  &do_no_restart_syscall, }, });
	    }' unless defined(&INIT_THREAD_INFO);
	    eval 'sub init_thread_info () {( ($init_thread_union->{thread_info}));}' unless defined(&init_thread_info);
	    eval 'sub init_stack () {( ($init_thread_union->{stack}));}' unless defined(&init_stack);
	    eval 'sub current_thread_info () {
	        eval q( &__current_thread_info);
	    }' unless defined(&current_thread_info);
	    if(defined( &CONFIG_PAGE_SIZE_4KB)  && defined( &CONFIG_32BIT)) {
		eval 'sub THREAD_SIZE_ORDER () {(1);}' unless defined(&THREAD_SIZE_ORDER);
	    }
	    if(defined( &CONFIG_PAGE_SIZE_4KB)  && defined( &CONFIG_64BIT)) {
		eval 'sub THREAD_SIZE_ORDER () {(2);}' unless defined(&THREAD_SIZE_ORDER);
	    }
	    if(defined(&CONFIG_PAGE_SIZE_8KB)) {
		eval 'sub THREAD_SIZE_ORDER () {(1);}' unless defined(&THREAD_SIZE_ORDER);
	    }
	    if(defined(&CONFIG_PAGE_SIZE_16KB)) {
		eval 'sub THREAD_SIZE_ORDER () {(0);}' unless defined(&THREAD_SIZE_ORDER);
	    }
	    if(defined(&CONFIG_PAGE_SIZE_64KB)) {
		eval 'sub THREAD_SIZE_ORDER () {(0);}' unless defined(&THREAD_SIZE_ORDER);
	    }
	    eval 'sub THREAD_SIZE () {( &PAGE_SIZE <<  &THREAD_SIZE_ORDER);}' unless defined(&THREAD_SIZE);
	    eval 'sub THREAD_MASK () {( &THREAD_SIZE - 1);}' unless defined(&THREAD_MASK);
	    if(defined(&CONFIG_DEBUG_STACK_USAGE)) {
		eval 'sub alloc_thread_info {
		    my($tsk) = @_;
    		    eval q(({ 1;  &ret =  &kmalloc( &THREAD_SIZE,  &GFP_KERNEL);  &if ( &ret)  &memset( &ret, 0,  &THREAD_SIZE);  &ret; }));
		}' unless defined(&alloc_thread_info);
	    } else {
		eval 'sub alloc_thread_info {
		    my($tsk) = @_;
    		    eval q( &kmalloc( &THREAD_SIZE,  &GFP_KERNEL));
		}' unless defined(&alloc_thread_info);
	    }
	    eval 'sub free_thread_info {
	        my($info) = @_;
    		eval q( &kfree($info));
	    }' unless defined(&free_thread_info);
	}
	eval 'sub PREEMPT_ACTIVE () {0x10000000;}' unless defined(&PREEMPT_ACTIVE);
	eval 'sub TIF_NOTIFY_RESUME () {1;}' unless defined(&TIF_NOTIFY_RESUME);
	eval 'sub TIF_SIGPENDING () {2;}' unless defined(&TIF_SIGPENDING);
	eval 'sub TIF_NEED_RESCHED () {3;}' unless defined(&TIF_NEED_RESCHED);
	eval 'sub TIF_SYSCALL_AUDIT () {4;}' unless defined(&TIF_SYSCALL_AUDIT);
	eval 'sub TIF_SECCOMP () {5;}' unless defined(&TIF_SECCOMP);
	eval 'sub TIF_RESTORE_SIGMASK () {9;}' unless defined(&TIF_RESTORE_SIGMASK);
	eval 'sub TIF_USEDFPU () {16;}' unless defined(&TIF_USEDFPU);
	eval 'sub TIF_POLLING_NRFLAG () {17;}' unless defined(&TIF_POLLING_NRFLAG);
	eval 'sub TIF_MEMDIE () {18;}' unless defined(&TIF_MEMDIE);
	eval 'sub TIF_SYSCALL_TRACE () {31;}' unless defined(&TIF_SYSCALL_TRACE);
	eval 'sub _TIF_SYSCALL_TRACE () {(1<< &TIF_SYSCALL_TRACE);}' unless defined(&_TIF_SYSCALL_TRACE);
	eval 'sub _TIF_NOTIFY_RESUME () {(1<< &TIF_NOTIFY_RESUME);}' unless defined(&_TIF_NOTIFY_RESUME);
	eval 'sub _TIF_SIGPENDING () {(1<< &TIF_SIGPENDING);}' unless defined(&_TIF_SIGPENDING);
	eval 'sub _TIF_NEED_RESCHED () {(1<< &TIF_NEED_RESCHED);}' unless defined(&_TIF_NEED_RESCHED);
	eval 'sub _TIF_SYSCALL_AUDIT () {(1<< &TIF_SYSCALL_AUDIT);}' unless defined(&_TIF_SYSCALL_AUDIT);
	eval 'sub _TIF_SECCOMP () {(1<< &TIF_SECCOMP);}' unless defined(&_TIF_SECCOMP);
	eval 'sub _TIF_RESTORE_SIGMASK () {(1<< &TIF_RESTORE_SIGMASK);}' unless defined(&_TIF_RESTORE_SIGMASK);
	eval 'sub _TIF_USEDFPU () {(1<< &TIF_USEDFPU);}' unless defined(&_TIF_USEDFPU);
	eval 'sub _TIF_POLLING_NRFLAG () {(1<< &TIF_POLLING_NRFLAG);}' unless defined(&_TIF_POLLING_NRFLAG);
	eval 'sub _TIF_WORK_MASK () {(0xffef & ~ &_TIF_SECCOMP);}' unless defined(&_TIF_WORK_MASK);
	eval 'sub _TIF_ALLWORK_MASK () {(0x8000ffff & ~ &_TIF_SECCOMP);}' unless defined(&_TIF_ALLWORK_MASK);
    }
}
1;
