require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_UACCESS_H)) {
    eval 'sub _ASM_UACCESS_H () {1;}' unless defined(&_ASM_UACCESS_H);
    require 'linux/kernel.ph';
    require 'linux/errno.ph';
    require 'linux/thread_info.ph';
    require 'asm-generic/uaccess.ph';
    if(defined(&CONFIG_32BIT)) {
	eval 'sub __UA_LIMIT () {0x80000000;}' unless defined(&__UA_LIMIT);
	eval 'sub __UA_ADDR () {".word";}' unless defined(&__UA_ADDR);
	eval 'sub __UA_LA () {"la";}' unless defined(&__UA_LA);
	eval 'sub __UA_ADDU () {"addu";}' unless defined(&__UA_ADDU);
	eval 'sub __UA_t0 () {"$8";}' unless defined(&__UA_t0);
	eval 'sub __UA_t1 () {"$9";}' unless defined(&__UA_t1);
    }
    if(defined(&CONFIG_64BIT)) {
	eval 'sub __UA_LIMIT () {(-  &TASK_SIZE);}' unless defined(&__UA_LIMIT);
	eval 'sub __UA_ADDR () {".dword";}' unless defined(&__UA_ADDR);
	eval 'sub __UA_LA () {"dla";}' unless defined(&__UA_LA);
	eval 'sub __UA_ADDU () {"daddu";}' unless defined(&__UA_ADDU);
	eval 'sub __UA_t0 () {"$12";}' unless defined(&__UA_t0);
	eval 'sub __UA_t1 () {"$13";}' unless defined(&__UA_t1);
    }
    eval 'sub KERNEL_DS () {(( &mm_segment_t) { 0 });}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () {(( &mm_segment_t) {  &__UA_LIMIT });}' unless defined(&USER_DS);
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( &current_thread_info()-> &addr_limit));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        my($x) = @_;
	    eval q(( &current_thread_info()-> &addr_limit = ($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        my($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __ua_size {
        my($size) = @_;
	    eval q((( &__builtin_constant_p  && ($size) > 0) ? 0: ($size)));
    }' unless defined(&__ua_size);
    eval 'sub __access_mask () { &get_fs(). &seg;}' unless defined(&__access_mask);
    eval 'sub __access_ok {
        my($addr, $size, $mask) = @_;
	    eval q((((($mask) & (($addr) | (($addr) + ($size)) |  &__ua_size($size)))) == 0));
    }' unless defined(&__access_ok);
    eval 'sub access_ok {
        my($type, $addr, $size) = @_;
	    eval q( &likely( &__access_ok(($addr), ($size), &__access_mask)));
    }' unless defined(&access_ok);
    eval 'sub put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_check(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&put_user);
    eval 'sub get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_check(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&get_user);
    eval 'sub __put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__put_user);
    eval 'sub __get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__get_user);
    eval 'sub __m {
        my($x) = @_;
	    eval q((*(1;
    }' unless defined(&__m);
    if(defined(&CONFIG_32BIT)) {
	eval 'sub __GET_USER_DW {
	    my($val, $ptr) = @_;
    	    eval q( &__get_user_asm_ll32($val, $ptr));
	}' unless defined(&__GET_USER_DW);
    }
    if(defined(&CONFIG_64BIT)) {
	eval 'sub __GET_USER_DW {
	    my($val, $ptr) = @_;
    	    eval q( &__get_user_asm($val, \\"ld\\", $ptr));
	}' unless defined(&__GET_USER_DW);
    }
    eval 'sub __get_user_common {
        my($val, $size, $ptr) = @_;
	    eval q( &do {  &switch ($size) {  &case 1:  &__get_user_asm($val, \\"lb\\", $ptr);  &break;  &case 2:  &__get_user_asm($val, \\"lh\\", $ptr);  &break;  &case 4:  &__get_user_asm($val, \\"lw\\", $ptr);  &break;  &case 8:  &__GET_USER_DW($val, $ptr);  &break;  &default:  &__get_user_unknown();  &break; } }  &while (0));
    }' unless defined(&__get_user_common);
    eval 'sub __get_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\';  &__get_user_common(($x), $size, $ptr);  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_check {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\' = - &EFAULT;  &const  &__typeof__(*($ptr))  &__user *  &__gu_ptr = ($ptr);  &if ( &likely( &access_ok( &VERIFY_READ,  &__gu_ptr, $size)))  &__get_user_common(($x), $size,  &__gu_ptr);  &__gu_err; }));
    }' unless defined(&__get_user_check);
    eval 'sub __get_user_asm {
        my($val, $insn, $addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_asm);
    eval 'sub __get_user_asm_ll32 {
        my($val, $addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_asm_ll32);
    if(defined(&CONFIG_32BIT)) {
	eval 'sub __PUT_USER_DW {
	    my($ptr) = @_;
    	    eval q( &__put_user_asm_ll32($ptr));
	}' unless defined(&__PUT_USER_DW);
    }
    if(defined(&CONFIG_64BIT)) {
	eval 'sub __PUT_USER_DW {
	    my($ptr) = @_;
    	    eval q( &__put_user_asm(\\"sd\\", $ptr));
	}' unless defined(&__PUT_USER_DW);
    }
    eval 'sub __put_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({  &__typeof__(*($ptr))  &__pu_val; \'long __pu_err\' = 0;  &__pu_val = ($x);  &switch ($size) {  &case 1:  &__put_user_asm(\\"sb\\", $ptr);  &break;  &case 2:  &__put_user_asm(\\"sh\\", $ptr);  &break;  &case 4:  &__put_user_asm(\\"sw\\", $ptr);  &break;  &case 8:  &__PUT_USER_DW($ptr);  &break;  &default:  &__put_user_unknown();  &break; }  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_check {
        my($x,$ptr,$size) = @_;
	    eval q(({  &__typeof__(*($ptr))  &__user * &__pu_addr = ($ptr);  &__typeof__(*($ptr))  &__pu_val = ($x); \'long __pu_err\' = - &EFAULT;  &if ( &likely( &access_ok( &VERIFY_WRITE,  &__pu_addr, $size))) {  &switch ($size) {  &case 1:  &__put_user_asm(\\"sb\\",  &__pu_addr);  &break;  &case 2:  &__put_user_asm(\\"sh\\",  &__pu_addr);  &break;  &case 4:  &__put_user_asm(\\"sw\\",  &__pu_addr);  &break;  &case 8:  &__PUT_USER_DW( &__pu_addr);  &break;  &default:  &__put_user_unknown();  &break; } }  &__pu_err; }));
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_asm {
        my($insn, $ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_asm);
    eval 'sub __put_user_asm_ll32 {
        my($ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_asm_ll32);
    if(defined(&MODULE)) {
	eval 'sub __MODULE_JAL {
	    my($destination) = @_;
    	    eval q(\\".set\\\\tnoat\\\\n\\\\t\\"  &__UA_LA \\"\\\\t$1, \\" $destination \\"\\\\n\\\\t\\" \\"jalr\\\\t$1\\\\n\\\\t\\" \\".set\\\\tat\\\\n\\\\t\\");
	}' unless defined(&__MODULE_JAL);
    } else {
	eval 'sub __MODULE_JAL {
	    my($destination) = @_;
    	    eval q(\\"jal\\\\t\\" $destination \\"\\\\n\\\\t\\");
	}' unless defined(&__MODULE_JAL);
    }
    eval 'sub __invoke_copy_to_user {
        my($to,$from,$n) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__invoke_copy_to_user);
    eval 'sub __copy_to_user {
        my($to,$from,$n) = @_;
	    eval q(({  &void  &__user * &__cu_to;  &const  &void * &__cu_from; \'long __cu_len\';  &might_sleep();  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &__cu_len =  &__invoke_copy_to_user( &__cu_to,  &__cu_from,  &__cu_len);  &__cu_len; }));
    }' unless defined(&__copy_to_user);
    eval 'sub __copy_to_user_inatomic () { &__copy_to_user;}' unless defined(&__copy_to_user_inatomic);
    eval 'sub __copy_from_user_inatomic () { &__copy_from_user;}' unless defined(&__copy_from_user_inatomic);
    eval 'sub copy_to_user {
        my($to,$from,$n) = @_;
	    eval q(({  &void  &__user * &__cu_to;  &const  &void * &__cu_from; \'long __cu_len\';  &might_sleep();  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &if ( &access_ok( &VERIFY_WRITE,  &__cu_to,  &__cu_len))  &__cu_len =  &__invoke_copy_to_user( &__cu_to,  &__cu_from,  &__cu_len);  &__cu_len; }));
    }' unless defined(&copy_to_user);
    eval 'sub __invoke_copy_from_user {
        my($to,$from,$n) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__invoke_copy_from_user);
    eval 'sub __copy_from_user {
        my($to,$from,$n) = @_;
	    eval q(({  &void * &__cu_to;  &const  &void  &__user * &__cu_from; \'long __cu_len\';  &might_sleep();  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &__cu_len =  &__invoke_copy_from_user( &__cu_to,  &__cu_from,  &__cu_len);  &__cu_len; }));
    }' unless defined(&__copy_from_user);
    eval 'sub copy_from_user {
        my($to,$from,$n) = @_;
	    eval q(({  &void * &__cu_to;  &const  &void  &__user * &__cu_from; \'long __cu_len\';  &might_sleep();  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &if ( &access_ok( &VERIFY_READ,  &__cu_from,  &__cu_len))  &__cu_len =  &__invoke_copy_from_user( &__cu_to,  &__cu_from,  &__cu_len);  &__cu_len; }));
    }' unless defined(&copy_from_user);
    eval 'sub __copy_in_user {
        my($to, $from, $n) = @_;
	    eval q( &__copy_from_user($to, $from, $n));
    }' unless defined(&__copy_in_user);
    eval 'sub copy_in_user {
        my($to,$from,$n) = @_;
	    eval q(({  &void  &__user * &__cu_to;  &const  &void  &__user * &__cu_from; \'long __cu_len\';  &might_sleep();  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &if ( &likely( &access_ok( &VERIFY_READ,  &__cu_from,  &__cu_len)  &&  &access_ok( &VERIFY_WRITE,  &__cu_to,  &__cu_len)))  &__cu_len =  &__invoke_copy_from_user( &__cu_to,  &__cu_from,  &__cu_len);  &__cu_len; }));
    }' unless defined(&copy_in_user);
    eval 'sub clear_user {
        my($addr,$n) = @_;
	    eval q(({  &void  &__user *  &__cl_addr = ($addr); \'unsigned long __cl_size\' = ($n);  &if ( &__cl_size  &&  &access_ok( &VERIFY_WRITE, (( &__cl_addr)),  &__cl_size))  &__cl_size =  &__clear_user( &__cl_addr,  &__cl_size);  &__cl_size; }));
    }' unless defined(&clear_user);
}
1;
